Subject: BackendConfigurationManager figures out wrong pid

Description

For backend modules, in Configuration/BackendConfigurationManager.php:getCurrentPageld() we try to find the current pid. If we are
in Web->, the id is readable via _GP('id'), everything is fine.

If we are outside Web->, there is no pid. The manager then tries to figure some useful pid out. It first looks for a page markes
"is_siteroot" and then a sys_template marked "root". While the treeroot is id 0, the manager will usually use id 1, because this is,

where the root template resides.

This causes problems with caching, because the core takes id 0 for "global" scope. For example the caches in
"cf_cache_pagesection" are generated (and tagged) for pid 0, if no specific pid is given.

While the method is currently protected and | don't think too much people will have their configurationManager inherited, this still would
be a breaking change. It's a bug, so breaking change would be ok, but some people mind find, it's not quiet the right time for that.

If that would be the case, | would propose deprecating this method and introducing a new one to deal with the pid correctly.

Related issues:
related to Core - Bug # 55028: Static TS must be available even when there is... Closed 2014-01-15
blocks Core - Task # 54701: Cache global TypoScript template in backend New 2014-01-02

Associated revisions

Revision ba2386e7 - 2014-01-09 20:26 - Felix Oertel

[BUGFIX] Assume pid 0 for global backend context

If outside from "Web", extbase modules try to figure out some pid,
while in reality there is just none. The core takes "0" in this
situations, for looking for typoscript templates and tagging

cf_cache_pagesection entries.

To enable extbase to use the core's cache entries, we should streamline
this.

- Return 0, if no pid is set
- Remove needless unit-tests
Reviewed-by: Oliver Klee
Reviewed-by: Stefan Froemken
Tested-by: Stefan Froemken
Reviewed-by: Anja Leichsenring
Tested-by: Anja Leichsenring

History

#1 - 2014-01-07 17:10 - Ernesto Baschny

Felix, go ahead and change that, if it's wrong. This is internal and not API, so | doubt that extensions are extending it.

| don't understand what you mean with "While the treeroot is id 0, the manager will usually use id 1, because this is, where the root template resides".

Maybe a patch in Gerrit will help us understand how you suggest to solve the problem.

Thanks for working on that!

#2 - 2014-01-07 17:38 - Felix Oertel

Hey Ernesto,

if we call a backend module outside "Web", it does not have a page selected. The core then assumes the pid "0", for example to look for typoscript

templates or to tag the caches (cf_cache_pagesection e.g.).

Extbase instead looks for the first page with "Use as Root Page" set and, if there is none, for the page where the first typoscript template with

"Rootlevel" set and takes that pid.

While | understand that intention, | don't think that makes any sense, because if no page is selected, it might be as wrong to take the first root-page /

-template as it might to take the last one or any other page.

| would go for the cores approach ... if the pid is set, good, if not, use 0.

#3 - 2014-01-07 18:08 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26675

#4 - 2014-01-09 15:35 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/26675

#5 - 2014-01-09 20:30 - Anonymous
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:ba2386e7305e0d6e64db5cc485bc38728728ad8e.

#6 - 2014-01-15 22:46 - Marc Bastian Heinrichs

Reverted with https://review.typo3.org/#/c/26864/

#7 - 2014-01-15 22:46 - Marc Bastian Heinrichs
- Status changed from Resolved to On Hold
- % Done changed from 100 to 0

#8 - 2014-01-15 23:25 - Ernesto Baschny

+1 on reverting that for now, thanks Ma-Ba for taking over. Let's think about better ways to achieve the desired result first.

#9 - 2014-02-14 18:55 - Ernesto Baschny
- Project changed from Extbase MVC Framework to Core
- Category deleted (Extbase: Configuration)

#10 - 2014-02-14 18:55 - Ernesto Baschny
- Category set to Extbase

- Is Regression set to No

- TYPO3 Version set to 6.2

#11 - 2014-02-14 20:20 - Ernesto Baschny
- Parent task set to #55079

#12 - 2015-06-10 15:48 - Alexander Opitz
- Status changed from On Hold to New
- Target version changed from 6.2.0 to 7 LTS

Remove OnHold and retarget for 7 ... it's to late for 6.2 (if it is breaking).
